<template>
		<el-dialog v-model="state.dialogVisible" draggable title="历史工单" ref="dialogRef" width="60%" append-to-body>
				<el-form :model="state.queryParams" ref="ruleFormRef" :inline="true" @submit.native.prevent>
					<el-form-item label="关键词" prop="Keyword">
						<el-input v-model="state.queryParams.Keyword" placeholder="工单标题/工单编码" clearable @keyup.enter="handleQuery" />
					</el-form-item>
					<el-form-item>
						<el-button type="primary" @click="handleQuery" :loading="state.loading"> <SvgIcon name="ele-Search" class="mr5" />查询 </el-button>
						<el-button @click="resetQuery(ruleFormRef)" class="default-button"> <SvgIcon name="ele-Refresh" class="mr5" />重置 </el-button>
					</el-form-item>
				</el-form>
				<el-table :data="state.tableData" @selection-change="handleSelectionChange" max-height="500" ref="multipleTableRef" row-key="id">
          <el-table-column type="selection" label="请选择" width="80" :reserve-selection="true"/>
					<el-table-column prop="phoneNo" label="工单标题" show-overflow-tooltip>
						<template #default="{row}">
							<span class="color-primary">{{ row.title }}</span>
						</template>
					</el-table-column>
					<el-table-column prop="hotspotName" label="热点分类" show-overflow-tooltip> </el-table-column>
					<el-table-column prop="no" label="工单编码" show-overflow-tooltip> </el-table-column>
					<el-table-column prop="currentStepName" label="当前环节" show-overflow-tooltip></el-table-column>
					<el-table-column prop="statusText" label="状态" width="70" fixed="right" align="center"></el-table-column>
          <el-table-column label="操作" width="150" fixed="right" align="center">
            <template #default="{ row }">
              <el-button type="primary" link @click="onSupply(row)" :loading="state.loading"  v-auth="'business:order:supply'">补充</el-button>
              <el-button type="primary" link @click="onRevoke(row)" :loading="state.loading"  v-auth="'business:order:revoke'">撤销</el-button>
              <el-button @click="onSupervise(row)" link type="primary" v-auth="'business:order:supervise'"> 督办 </el-button>
            </template>
          </el-table-column>
					<template #empty>
						<Empty />
					</template>
				</el-table>
				<pagination
					:total="state.total"
					v-model:page="state.queryParams.PageIndex"
					v-model:limit="state.queryParams.PageSize"
					@pagination="getList"
				/>
			<template #footer>
				<span class="dialog-footer">
					<el-button class="default-button" @click="state.dialogVisible = false">取 消</el-button>
					<el-button type="primary" @click="selectConfirm" :disabled="!multipleSelection.length">确 定</el-button>
				</span>
			</template>
		</el-dialog>
    <!-- 工单补充 -->
    <order-supply ref="orderSupplyRef" @onSupplySuccess="onSupplySuccess" />
    <!-- 工单撤销 -->
    <order-revoke ref="orderRevokeRef" @onRevokeSuccess="onRevokeSuccess" />
    <!-- 工单督办 -->
    <order-super-vise ref="orderSuperviseRef" @onSuperviseSuccess="onSuperviseSuccess" />
</template>

<script setup lang="ts" name="orderHistory">
import {defineAsyncComponent, reactive, ref} from 'vue';
import type { FormInstance } from 'element-plus';
import { historyOrder } from '/@/api/business/order';
import { useRoute } from 'vue-router';
// import { ElMessage } from 'element-plus';
// 引入组件
const OrderSupply = defineAsyncComponent(() => import('/@/views/business/order/components/Order-supply.vue'));  // 补充组件
const OrderRevoke = defineAsyncComponent(() => import('/@/views/business/order/components/Order-revoke.vue'));  // 撤销组件
const OrderSuperVise = defineAsyncComponent(() => import('/@/views/business/supervise/components/Order-supervise.vue'));  // 工单督办
const emit = defineEmits(['saveSelect']);
// 定义变量内容
const state = reactive<any>({
	dialogVisible: false, // 弹窗显示隐藏
	queryParams: {
		PageIndex: 1, // 当前页
		PageSize: 10, // 每页条数
		Keyword: '',  // 关键字
	},
	tableData: [], // 表格数据
	total: 0,   // 总条数
	loading: false, // 加载状态
	ruleForm: {}, // 表单数据
});
const ruleFormRef = ref<RefType>(); // 表单ref
const route = useRoute(); // 路由
const multipleSelection = ref<any[]>([]); // 选中的数据
const multipleTableRef = ref<RefType>();  // 表格ref
// 打开弹窗
const openDialog = (row: any) => {
	state.ruleForm = row;
	getList();
	state.dialogVisible = true;
};
const dialogRef = ref<RefType>();
// 关闭弹窗
const closeDialog = () => {
	state.dialogVisible = false;
};
/** 搜索按钮操作 */
const handleQuery = () => {
	state.queryParams.PageIndex = 1;
	getList();
};
/** 重置按钮操作 */
const resetQuery = (formEl: FormInstance | undefined) => {
	if (!formEl) return;
	formEl.resetFields();
	handleQuery();
};
/** 获取历史工单 */
const getList = () => {
	if (!state.ruleForm.contact) return;
	state.loading = true;
	let request = {
		...state.queryParams,
		PhoneNo: state.ruleForm.contact,
		OrderId: route.params.id ?? '', //传入id 排除重复工单选择自己
	};
	historyOrder(request)
		.then((response: any) => {
			state.tableData = response?.result.items ?? [];
      multipleTableRef.value!.clearSelection();
      if(state.ruleForm.duplicateIds && state.ruleForm.duplicateIds.length){
        for(let i of state.ruleForm.duplicateIds){
          for(let j of state.tableData){
            if(i === j.id){
              setTimeout(() => {
                multipleTableRef.value!.toggleRowSelection(j, true);
                multipleSelection.value.push(j);
              }, 0);
            }
          }
        }
      }else{
        multipleSelection.value = [];
        multipleTableRef.value!.clearSelection();
      }
			state.total = response?.result.total;
			state.loading = false;
		})
		.catch(() => {
			state.loading = false;
		});
};
// 选择重复件
const handleSelectionChange = (row: any) => {
	if (row) {
    multipleSelection.value = row
	}
};
// 补充
const orderSupplyRef = ref<RefType>(); // 补充ref
const onSupply = (row: any) => {
  // 穿入当前流程id
  orderSupplyRef.value.openDialog(row);
};
// 补充意见提交成功
const onSupplySuccess = () => {
  // 关闭弹窗
  orderSupplyRef.value.closeDialog();
  // 刷新列表
  getList();
};
// 撤销
const orderRevokeRef = ref<RefType>()
const onRevoke = (row: any)=>{
  orderRevokeRef.value.openDialog(row);
}
// 撤销提交成功
const onRevokeSuccess = ()=>{
  // 关闭弹窗
  orderRevokeRef.value.closeDialog();
  // 刷新列表
  getList();
}
// 督办
const orderSuperviseRef = ref<RefType>(); // 工单督办
const onSupervise = () => {
  orderSuperviseRef.value.openDialog(state.ruleForm);
};
// 督办提交成功
const onSuperviseSuccess = () => {
  // 刷新列表
  getList();
};
// 确定选择历史工单
const selectConfirm = () => {
	emit('saveSelect', multipleSelection.value);
};
// 暴露变量
defineExpose({
	openDialog,
	closeDialog,
});
</script>
